% gore.m Help file for gore MEX-file
% 
% GORE removes true outliers for 3D rotation search. 
%   [H, R, outlwbnd ] = gore( X, Y, th, lwbnd, repeat )
%    
%   INPUT:
%     X,Y are 3xn matrices such that a correspondence (x,y) is stored at
%     same column index in X and Y. 
%     th is the angular treshold defining a true match.
%     lwbnd is a known lower bound for the number of true correspondences.
%     repeat can take values 1 and 0. 0 for the original GORE algorithm and
%     1 to repeat GORE until no outlier can be removed. 
%
%   OUTPUT:
%     H indices of columns remaining after removing outliers
%     R GORE's sub-optimal matrix.
%     outlwbnd Output lower bound. 

